/*****************************************************************************/
//
//  Copyright (c) Jim Buzbee 1996
//
//  jbuzbee@nyx.net
//  House Blend Software
//
// Permission to use, copy, modify, and distribute this software
// for non-commercial uses is hereby granted provided
// this notice is kept intact within the source file
//
/***************************************************************************/

public abstract class Ticket
{
  private static int ticket = 0;
  private static int current = -1;


  // note that we should only be checking files that make sense for the
  // platform type.... perhaps next time...

  private static String urls[] = {"/etc/passwd",
                                  "/usr",
                                  "/msoffice",
                                  "/d:/msoffice",
                                  "/c:/",
                                  "/home/"
                                 };

  // this is a bit of a hack.  This array has to be the same size as
  // the urls array... ugly...ugly
  private static boolean URLState[] = { false, 
                                        false, 
                                        false, 
                                        false, 
                                        false,
                                        false
                                        };

  // nobody's ready yet...
  private static boolean masterReady = false;
  private static boolean slaveReady = false;
  private static String readerBase;

  //**************************************************************
  public static void setCurrent (int i)
  {
    current = i;
  }
  //**************************************************************

  public static void reset()
  {
     for ( int i = 0; i < URLState.length; i++ )
     {
        URLState[i] = false;
     }
     current = -1;
     masterReady = false;
     slaveReady = false;
  }
  //**************************************************************
  public static int getUrls ()
  {
     return( URLState.length );
  }
  //**************************************************************

  public static int getCurrent ()
  {
    // get yer tickets here...
    return current;
  }
  //**************************************************************
  public static void setMaster ( boolean Ready)
  {
    masterReady = Ready;
  }
  //**************************************************************
  public static boolean getMaster ()
  {
    return masterReady;
  }
  //**************************************************************
  public static synchronized void setSlave ( boolean Ready)
  {
    slaveReady = Ready;
  }
  //**************************************************************
  public static boolean getSlave ()
  {
    return slaveReady;
  }
  //**************************************************************
  public static void setURLState( boolean exists )
  {
    URLState[ current ] = exists;
  }
  //**************************************************************
  public static boolean getURLState ()
  {
    return URLState[ current ];
  }
  //**************************************************************
  public static String getURL ()
  {
    return urls[ current ];
  }
  //**************************************************************
  public static String getReaderBase ()
  {
    return readerBase;
  }
  //**************************************************************
  public static void setReaderBase ( String base )
  {
    readerBase = base;
  }
  //**************************************************************
}
