/*****************************************************************************/
//
//  Copyright (c) Jim Buzbee 1996
//
//  jbuzbee@nyx.net
//  House Blend Software
//
// Permission to use, copy, modify, and distribute this software
// for non-commercial uses is hereby granted provided
// this notice is kept intact within the source file
//
/***************************************************************************/

import java.awt.*;
import Ticket;
import java.net.URL;

//******************************************************************

public class TicketHolder extends java.applet.Applet implements Runnable
{
  private int ticket = 1;
  Thread runner;
  URL theURL = null;
  TextArea ta;
  static boolean first = true;

  //******************************************************************

  public void init ()
  {     
    Ticket.reset();

    ta = new TextArea( "", 10, 60 );

    add(ta);

  }
  //******************************************************************
  public void start ()
  {
    // if this is not the first start
    if ( ! first )
    {
       // try to get everything in synch
       Ticket.reset();

       // reload the client, his state is unknown
       getAppletContext().showDocument( theURL, "reader");

       // give up our slice
       runner.yield();

       // pause for good measure
       pause( 1000 );

       ta.appendText( "Restart in Master\n" );

       synchUp();
    }

    first = false;

    if (runner == null)
    {
	runner = new Thread (this);
	runner.start ();
    }

  }
  //******************************************************************

  public void stop ()
  {
    if (runner != null)
    {
        Ticket.reset();
	runner.stop ();
	runner = null;
    }
  }
  //******************************************************************

  public void run ()
  {
    // make sure we are in lock-step synch
    synchUp();

    try
    {
       // get the readers URL
      theURL = new URL( Ticket.getReaderBase() );
    }
    catch ( java.net.MalformedURLException e ) 
    { 
       System.out.println("MASTER: BAD URL " + theURL);
    }

    Ticket.setCurrent( 0 );

    while (true)
    {
      int k;
      int i;

      i = Ticket.getCurrent();

      System.out.println("MASTER: checking " + Ticket.getURL() );
      ta.appendText( "Checking " + Ticket.getURL() );

      runner.yield();

      k = 0;

      // while the ticket has not been puched or we waited long enough
      // we likely could be a lot smarter here, but this seems to work
      while ( ( ! Ticket.getURLState() ) && ( k++ < 10 ) )
      {
         ta.appendText( "." );
         runner.yield();

         pause( 1000 );
      }

      ta.appendText( ", " + Ticket.getURL() );

      // if the ticket has been punched
      if ( Ticket.getURLState() )
      {
         ta.appendText( " exists\n" );

         System.out.println("MASTER: " + Ticket.getURL() + " exists" );
      }
      else
      {
         ta.appendText( " does not exist\n" );

         System.out.println("MASTER: " + Ticket.getURL() + " does not exist ");
      }

      // if we have any more to check
      if ( i < ( Ticket.getUrls()-1 ) )
      {
         // bump the count
         Ticket.setCurrent( i+1 );

         Ticket.setMaster( false );
         Ticket.setSlave( false );

         // start him up to check the new file
         getAppletContext().showDocument( theURL, "reader");

         // let the client get some time
         runner.yield();
      }
      else
      {
         ta.appendText( "\nAll Done! Thanks for the fish !\n\n" );

         // reset in case the client get's restarted
         Ticket.reset();

         this.stop();
         
         return;
      }

      // synch back up with the client
      synchUp();

    }
  }
  //******************************************************************

  public void pause (int time)
  {
    try
    {
      runner.sleep (time);
    }
    catch (InterruptedException e)
    {
    }
  }
  //******************************************************************

  public void synchUp()
  {
    // we are ready
    Ticket.setMaster( true );

    System.out.print("MASTER: waiting on slave");

    // while the slave is not
    while ( ! Ticket.getSlave() )
    {
      pause(1000);
      System.out.print(".");
    }

    System.out.println("\n");

    return;
  }
  //******************************************************************

}
