/*****************************************************************************/
//
//  Copyright (c) Jim Buzbee 1996
//
//  jbuzbee@nyx.net
//  House Blend Software
//
// Permission to use, copy, modify, and distribute this software
// for non-commercial uses is hereby granted provided
// this notice is kept intact within the source file
//
/***************************************************************************/

import java.awt. *;
import Ticket;
import java.net.URL;

/***************************************************************************/

public class TicketReader extends java.applet.Applet implements Runnable
{
  Thread runner;
  URL theURL = null;
  boolean Good = true;

  public void init()
  {
    System.out.println("SLAVE: Slave up in init() ");

    // let the master know where we came from
    Ticket.setReaderBase( "" + getDocumentBase() );

    // while the master is not ready for us
    while ( ! Ticket.getMaster() )
    {
      // System.out.println("SLAVE: waiting for master ");
      pause(1000);
    }

    System.out.println("SLAVE: master's up ");

    // and so are we...
    Ticket.setSlave( true );
  }
  //************************************************************************
  public void start ()
  {
    if (runner == null)
    {
       runner = new Thread (this);
       runner.start ();
    }
  }
  //************************************************************************

  public void stop ()
  {
    if (runner != null)
    {
       // if this was on account of the showDocument call
       if ( ! Good )
       {
          // reflect that fact
          System.out.println("SLAVE: Stopped called setting url true");

          Ticket.setURLState( true);
       }
       else
       {
         System.out.println("SLAVE: Normal stop called ");
       }

       // shut 'er down boys...
       runner.stop ();
       runner = null;
    }
  }

  //************************************************************************
  public void run ()
  {
       // while we don't have a valid ticket
       while ( Ticket.getCurrent() < 0 )
       {
 	 pause(1000);
       }

       try
       {
         // build a URL object associated with the url string
         theURL = new URL( "file:" +  Ticket.getURL() );
       }
       catch ( java.net.MalformedURLException e ) 
       { 
          // whoops !
          System.out.println("SLAVE: BAD URL " + theURL);
       }

       Good = false;

       System.out.println("SLAVE: Checking file:" + Ticket.getURL() );

       // this is it, the call we've been waiting for...
       getAppletContext().showDocument( theURL, "reader" );

       System.out.println("SLAVE: Sleeping after showDocument");

       // let someone else take over
       runner.yield();
       
       // this could be shorter ?
       pause(5000);

       System.out.println("SLAVE: Done sleeping after showDocument");

       Good = true;

       runner.stop();
       runner = null;
    }
  //************************************************************************

  public void pause (int time)
  {
    try
    {
      runner.sleep (time);
    }
    catch (InterruptedException e)
    {
    }
  }
  //************************************************************************
}
